diff --git a/arch/arm/mach-omap2/Kconfig b/arch/arm/mach-omap2/Kconfig
index 4c87cbc00f74..48bc80a6390a 100644
--- a/arch/arm/mach-omap2/Kconfig
+++ b/arch/arm/mach-omap2/Kconfig
@@ -181,7 +181,6 @@ source "board/BuR/brppt1/Kconfig"
 source "board/siemens/draco/Kconfig"
 source "board/siemens/pxm2/Kconfig"
 source "board/siemens/rut/Kconfig"
-source "board/ti/ti814x/Kconfig"
 source "board/ti/ti816x/Kconfig"
 source "board/ti/am43xx/Kconfig"
 source "board/ti/am335x/Kconfig"
diff --git a/board/ti/ti814x/Kconfig b/board/ti/ti814x/Kconfig
deleted file mode 100644
index 2960099a8e5b..000000000000
--- a/board/ti/ti814x/Kconfig
+++ /dev/null
@@ -1,15 +0,0 @@
-if TARGET_TI814X_EVM
-
-config SYS_BOARD
-	default "ti814x"
-
-config SYS_VENDOR
-	default "ti"
-
-config SYS_SOC
-	default "am33xx"
-
-config SYS_CONFIG_NAME
-	default "ti814x_evm"
-
-endif
diff --git a/board/ti/ti814x/MAINTAINERS b/board/ti/ti814x/MAINTAINERS
deleted file mode 100644
index b2ee39e8a339..000000000000
--- a/board/ti/ti814x/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-TI814X BOARD
-M:	Tom Rini <trini at konsulko.com>
-S:	Maintained
-F:	board/ti/ti814x/
-F:	include/configs/ti814x_evm.h
-F:	configs/ti814x_evm_defconfig
diff --git a/board/ti/ti814x/Makefile b/board/ti/ti814x/Makefile
deleted file mode 100644
index c5ff8d072851..000000000000
--- a/board/ti/ti814x/Makefile
+++ /dev/null
@@ -1,11 +0,0 @@
-# SPDX-License-Identifier: GPL-2.0+
-#
-# Makefile
-#
-# Copyright (C) 2013 Texas Instruments Incorporated - http://www.ti.com/
-
-ifdef CONFIG_SPL_BUILD
-obj-y	:= mux.o
-endif
-
-obj-y	+= evm.o
diff --git a/board/ti/ti814x/evm.c b/board/ti/ti814x/evm.c
deleted file mode 100644
index 8ed80d2f4627..000000000000
--- a/board/ti/ti814x/evm.c
+++ /dev/null
@@ -1,190 +0,0 @@
-// SPDX-License-Identifier: GPL-2.0+
-/*
- * evm.c
- *
- * Board functions for TI814x EVM
- *
- * Copyright (C) 2011, Texas Instruments, Incorporated - http://www.ti.com/
- */
-
-#include <common.h>
-#include <cpsw.h>
-#include <env.h>
-#include <errno.h>
-#include <init.h>
-#include <net.h>
-#include <spl.h>
-#include <asm/arch/cpu.h>
-#include <asm/arch/hardware.h>
-#include <asm/arch/omap.h>
-#include <asm/arch/ddr_defs.h>
-#include <asm/arch/clock.h>
-#include <asm/arch/gpio.h>
-#include <asm/arch/mmc_host_def.h>
-#include <asm/arch/sys_proto.h>
-#include <asm/io.h>
-#include <asm/emif.h>
-#include <asm/gpio.h>
-#include "evm.h"
-
-DECLARE_GLOBAL_DATA_PTR;
-
-static struct ctrl_dev *cdev = (struct ctrl_dev *)CTRL_DEVICE_BASE;
-
-/* UART Defines */
-#ifdef CONFIG_SPL_BUILD
-static const struct cmd_control evm_ddr2_cctrl_data = {
-	.cmd0csratio	= 0x80,
-	.cmd0iclkout	= 0x00,
-
-	.cmd1csratio	= 0x80,
-	.cmd1iclkout	= 0x00,
-
-	.cmd2csratio	= 0x80,
-	.cmd2iclkout	= 0x00,
-};
-
-static const struct emif_regs evm_ddr2_emif0_regs = {
-	.sdram_config			= 0x40801ab2,
-	.ref_ctrl			= 0x10000c30,
-	.sdram_tim1			= 0x0aaaf552,
-	.sdram_tim2			= 0x043631d2,
-	.sdram_tim3			= 0x00000327,
-	.emif_ddr_phy_ctlr_1		= 0x00000007
-};
-
-static const struct emif_regs evm_ddr2_emif1_regs = {
-	.sdram_config			= 0x40801ab2,
-	.ref_ctrl			= 0x10000c30,
-	.sdram_tim1			= 0x0aaaf552,
-	.sdram_tim2			= 0x043631d2,
-	.sdram_tim3			= 0x00000327,
-	.emif_ddr_phy_ctlr_1		= 0x00000007
-};
-
-const struct dmm_lisa_map_regs evm_lisa_map_regs = {
-	.dmm_lisa_map_0			= 0x00000000,
-	.dmm_lisa_map_1			= 0x00000000,
-	.dmm_lisa_map_2			= 0x806c0300,
-	.dmm_lisa_map_3			= 0x806c0300,
-};
-
-static const struct ddr_data evm_ddr2_data = {
-	.datardsratio0		= ((0x35<<10) | (0x35<<0)),
-	.datawdsratio0		= ((0x20<<10) | (0x20<<0)),
-	.datawiratio0		= ((0<<10) | (0<<0)),
-	.datagiratio0		= ((0<<10) | (0<<0)),
-	.datafwsratio0		= ((0x90<<10) | (0x90<<0)),
-	.datawrsratio0		= ((0x50<<10) | (0x50<<0)),
-};
-
-void set_uart_mux_conf(void)
-{
-	/* Set UART pins */
-	enable_uart0_pin_mux();
-}
-
-void set_mux_conf_regs(void)
-{
-	/* Set MMC pins */
-	enable_mmc1_pin_mux();
-
-	/* Set Ethernet pins */
-	enable_enet_pin_mux();
-}
-
-void sdram_init(void)
-{
-	config_dmm(&evm_lisa_map_regs);
-
-	config_ddr(0, NULL, &evm_ddr2_data, &evm_ddr2_cctrl_data,
-		   &evm_ddr2_emif0_regs, 0);
-	config_ddr(0, NULL, &evm_ddr2_data, &evm_ddr2_cctrl_data,
-		   &evm_ddr2_emif1_regs, 1);
-}
-#endif
-
-/*
- * Basic board specific setup.  Pinmux has been handled already.
- */
-int board_init(void)
-{
-	gd->bd->bi_boot_params = CONFIG_SYS_SDRAM_BASE + 0x100;
-	return 0;
-}
-
-#if defined(CONFIG_MMC)
-int board_mmc_init(bd_t *bis)
-{
-	omap_mmc_init(1, 0, 0, -1, -1);
-
-	return 0;
-}
-#endif
-
-#ifdef CONFIG_DRIVER_TI_CPSW
-static void cpsw_control(int enabled)
-{
-	/* VTP can be added here */
-
-	return;
-}
-
-static struct cpsw_slave_data cpsw_slaves[] = {
-	{
-		.slave_reg_ofs	= 0x50,
-		.sliver_reg_ofs	= 0x700,
-		.phy_addr	= 1,
-	},
-	{
-		.slave_reg_ofs	= 0x90,
-		.sliver_reg_ofs	= 0x740,
-		.phy_addr	= 0,
-	},
-};
-
-static struct cpsw_platform_data cpsw_data = {
-	.mdio_base		= CPSW_MDIO_BASE,
-	.cpsw_base		= CPSW_BASE,
-	.mdio_div		= 0xff,
-	.channels		= 8,
-	.cpdma_reg_ofs		= 0x100,
-	.slaves			= 1,
-	.slave_data		= cpsw_slaves,
-	.ale_reg_ofs		= 0x600,
-	.ale_entries		= 1024,
-	.host_port_reg_ofs	= 0x28,
-	.hw_stats_reg_ofs	= 0x400,
-	.bd_ram_ofs		= 0x2000,
-	.mac_control		= (1 << 5),
-	.control		= cpsw_control,
-	.host_port_num		= 0,
-	.version		= CPSW_CTRL_VERSION_1,
-};
-#endif
-
-int board_eth_init(bd_t *bis)
-{
-	uint8_t mac_addr[6];
-	uint32_t mac_hi, mac_lo;
-
-	if (!eth_env_get_enetaddr("ethaddr", mac_addr)) {
-		printf("<ethaddr> not set. Reading from E-fuse\n");
-		/* try reading mac address from efuse */
-		mac_lo = readl(&cdev->macid0l);
-		mac_hi = readl(&cdev->macid0h);
-		mac_addr[0] = mac_hi & 0xFF;
-		mac_addr[1] = (mac_hi & 0xFF00) >> 8;
-		mac_addr[2] = (mac_hi & 0xFF0000) >> 16;
-		mac_addr[3] = (mac_hi & 0xFF000000) >> 24;
-		mac_addr[4] = mac_lo & 0xFF;
-		mac_addr[5] = (mac_lo & 0xFF00) >> 8;
-
-		if (is_valid_ethaddr(mac_addr))
-			eth_env_set_enetaddr("ethaddr", mac_addr);
-		else
-			printf("Unable to read MAC address. Set <ethaddr>\n");
-	}
-
-	return cpsw_register(&cpsw_data);
-}
diff --git a/board/ti/ti814x/evm.h b/board/ti/ti814x/evm.h
deleted file mode 100644
index 6aebec62d4a4..000000000000
--- a/board/ti/ti814x/evm.h
+++ /dev/null
@@ -1,8 +0,0 @@
-#ifndef _EVM_H
-#define _EVM_H
-
-void enable_uart0_pin_mux(void);
-void enable_mmc1_pin_mux(void);
-void enable_enet_pin_mux(void);
-
-#endif /* _EVM_H */
diff --git a/board/ti/ti814x/mux.c b/board/ti/ti814x/mux.c
deleted file mode 100644
index fd9f36451158..000000000000
--- a/board/ti/ti814x/mux.c
+++ /dev/null
@@ -1,86 +0,0 @@
-/*
- * mux.c
- *
- * Copyright (C) 2011 Texas Instruments Incorporated - http://www.ti.com/
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation version 2.
- *
- * This program is distributed "as is" WITHOUT ANY WARRANTY of any
- * kind, whether express or implied; without even the implied warranty
- * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
- * GNU General Public License for more details.
- */
-
-#include <common.h>
-#include <asm/arch/sys_proto.h>
-#include <asm/arch/hardware.h>
-#include <asm/arch/mux.h>
-#include <asm/io.h>
-#include <i2c.h>
-#include "evm.h"
-
-static struct module_pin_mux uart0_pin_mux[] = {
-	{OFFSET(pincntl70), PULLUP_EN | MODE(0x01)},	/* UART0_RXD */
-	{OFFSET(pincntl71), PULLUP_EN | MODE(0x01)},	/* UART0_TXD */
-	{-1},
-};
-
-static struct module_pin_mux mmc1_pin_mux[] = {
-	{OFFSET(pincntl1), PULLUP_EN | MODE(0x01)},	/* SD1_CLK */
-	{OFFSET(pincntl2), PULLUP_EN | MODE(0x01)},	/* SD1_CMD */
-	{OFFSET(pincntl3), PULLUP_EN | MODE(0x01)},	/* SD1_DAT[0] */
-	{OFFSET(pincntl4), PULLUP_EN | MODE(0x01)},	/* SD1_DAT[1] */
-	{OFFSET(pincntl5), PULLUP_EN | MODE(0x01)},	/* SD1_DAT[2] */
-	{OFFSET(pincntl6), PULLUP_EN | MODE(0x01)},	/* SD1_DAT[3] */
-	{OFFSET(pincntl74), PULLUP_EN | MODE(0x40)},	/* SD1_POW */
-	{OFFSET(pincntl75), MODE(0x40)},		/* SD1_SDWP */
-	{OFFSET(pincntl80), PULLUP_EN | MODE(0x02)},	/* SD1_SDCD */
-	{-1},
-};
-
-static struct module_pin_mux enet_pin_mux[] = {
-	{OFFSET(pincntl232), MODE(0x01)},		/* EMAC_RMREFCLK */
-	{OFFSET(pincntl233), PULLUP_EN | MODE(0x01)},	/* MDCLK */
-	{OFFSET(pincntl234), PULLUP_EN | MODE(0x01)},	/* MDIO */
-	{OFFSET(pincntl235), MODE(0x01)},		/* EMAC[0]_MTCLK */
-	{OFFSET(pincntl236), MODE(0x01)},		/* EMAC[0]_MCOL */
-	{OFFSET(pincntl237), MODE(0x01)},		/* EMAC[0]_MCRS */
-	{OFFSET(pincntl238), MODE(0x01)},		/* EMAC[0]_MRXER */
-	{OFFSET(pincntl239), MODE(0x01)},		/* EMAC[0]_MRCLK */
-	{OFFSET(pincntl240), MODE(0x01)},		/* EMAC[0]_MRXD[0] */
-	{OFFSET(pincntl241), MODE(0x01)},		/* EMAC[0]_MRXD[1] */
-	{OFFSET(pincntl242), MODE(0x01)},		/* EMAC[0]_MRXD[2] */
-	{OFFSET(pincntl243), MODE(0x01)},		/* EMAC[0]_MRXD[3] */
-	{OFFSET(pincntl244), MODE(0x01)},		/* EMAC[0]_MRXD[4] */
-	{OFFSET(pincntl245), MODE(0x01)},		/* EMAC[0]_MRXD[5] */
-	{OFFSET(pincntl246), MODE(0x01)},		/* EMAC[0]_MRXD[6] */
-	{OFFSET(pincntl247), MODE(0x01)},		/* EMAC[0]_MRXD[7] */
-	{OFFSET(pincntl248), MODE(0x01)},		/* EMAC[0]_MRXDV */
-	{OFFSET(pincntl249), MODE(0x01)},		/* EMAC[0]_GMTCLK */
-	{OFFSET(pincntl250), MODE(0x01)},		/* EMAC[0]_MTXD[0] */
-	{OFFSET(pincntl251), MODE(0x01)},		/* EMAC[0]_MTXD[1] */
-	{OFFSET(pincntl252), MODE(0x01)},		/* EMAC[0]_MTXD[2] */
-	{OFFSET(pincntl253), MODE(0x01)},		/* EMAC[0]_MTXD[3] */
-	{OFFSET(pincntl254), MODE(0x01)},		/* EMAC[0]_MTXD[4] */
-	{OFFSET(pincntl255), MODE(0x01)},		/* EMAC[0]_MTXD[5] */
-	{OFFSET(pincntl256), MODE(0x01)},		/* EMAC[0]_MTXD[6] */
-	{OFFSET(pincntl257), MODE(0x01)},		/* EMAC[0]_MTXD[7] */
-	{OFFSET(pincntl258), MODE(0x01)},		/* EMAC[0]_MTXEN */
-};
-
-void enable_uart0_pin_mux(void)
-{
-	configure_module_pin_mux(uart0_pin_mux);
-}
-
-void enable_mmc1_pin_mux(void)
-{
-	configure_module_pin_mux(mmc1_pin_mux);
-}
-
-void enable_enet_pin_mux(void)
-{
-	configure_module_pin_mux(enet_pin_mux);
-}
diff --git a/configs/ti814x_evm_defconfig b/configs/ti814x_evm_defconfig
deleted file mode 100644
index 71c9119c7d06..000000000000
--- a/configs/ti814x_evm_defconfig
+++ /dev/null
@@ -1,45 +0,0 @@
-CONFIG_ARM=y
-CONFIG_ARCH_CPU_INIT=y
-CONFIG_ARCH_OMAP2PLUS=y
-CONFIG_SPL_GPIO_SUPPORT=y
-CONFIG_SPL_LIBCOMMON_SUPPORT=y
-CONFIG_SPL_LIBGENERIC_SUPPORT=y
-CONFIG_TI814X=y
-CONFIG_TARGET_TI814X_EVM=y
-CONFIG_SPL_MMC_SUPPORT=y
-CONFIG_SPL_SERIAL_SUPPORT=y
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_SPL=y
-CONFIG_SPL_FS_FAT=y
-CONFIG_SPL_LIBDISK_SUPPORT=y
-CONFIG_SPL_TEXT_BASE=0x40300000
-CONFIG_ENV_VARS_UBOOT_CONFIG=y
-CONFIG_BOOTDELAY=1
-CONFIG_SYS_CONSOLE_INFO_QUIET=y
-# CONFIG_MISC_INIT_R is not set
-CONFIG_VERSION_VARIABLE=y
-# CONFIG_DISPLAY_CPUINFO is not set
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_SYS_MMCSD_RAW_MODE_U_BOOT_USE_SECTOR=y
-CONFIG_SYS_MMCSD_RAW_MODE_U_BOOT_SECTOR=0x300
-CONFIG_SPL_YMODEM_SUPPORT=y
-CONFIG_HUSH_PARSER=y
-# CONFIG_CMDLINE_EDITING is not set
-# CONFIG_AUTO_COMPLETE is not set
-CONFIG_SYS_PROMPT="U-Boot# "
-CONFIG_CMD_ASKENV=y
-CONFIG_CMD_MMC=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_DHCP=y
-CONFIG_CMD_MII=y
-CONFIG_CMD_PING=y
-CONFIG_CMD_EXT2=y
-CONFIG_CMD_FAT=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_ENV_VARS_UBOOT_RUNTIME_CONFIG=y
-CONFIG_MMC_OMAP_HS=y
-CONFIG_PHY_ET1011C=y
-CONFIG_MII=y
-CONFIG_DRIVER_TI_CPSW=y
-CONFIG_SYS_NS16550=y
-CONFIG_OF_LIBFDT=y